"""file: heap.py -- correction td6, exercises about heaps

"""

import random

def heap_at(li,p):
  """makes li a heap at position p if it is already a heap at every
  descendant of p.

  """
  g,d,stop = 2*p,2*p+1,li[0]
  if g > stop: return None
  else:
    k = g if (d>stop or li[g]>li[d]) else d
    if li[k]>li[p]:
      li[k],li[p] = li[p],li[k]
      heap_at(li,k)
    return None

def heapify(li):
  """makes li a heap at every nodes : starting from the leaves and going
  upward with the help of heap_at.

  """
  stop = li[0]
  for p in range(stop/2,0,-1):
    heap_at(li,p)
  return None 

def heapsort(li):
  """returns a sorted copy of li by making it a heap and using heap sort

  """
  tmp = [len(li)] + li[:]
  heapify(tmp)
  for n in range(len(tmp)-1,0,-1):
    tmp[n],tmp[1] = tmp[1],tmp[n]
    tmp[0] -= 1
    heap_at(tmp,1)
  return tmp[1:]

li = [random.randrange(1,100) for i in range(20)]
print li
print heapsort(li)
