"""file: queue.py -- correction td6, exercises about unbounded queues

"""

import random

def uniform(q):
  n,m = len(q[0]),len(q[1])
  if n == 0:
    q[0] = q[1][:m//2][::-1]
    q[1] = q[1][m//2:]
  elif m == 0:
    k = n//2 + (1 if n % 2 else 0)
    q[1] = q[0][:k][::-1]
    q[0] = q[0][k:]

def empty(): return [[],[]]

def is_empty(q):
  return len(q[0]) == 0 and len(q[1]) == 0

def queue(q,elt):
  q[0].append(elt)
  uniform(q)

def dequeue(q):
  x = q[1][-1]
  del q[1][-1]
  uniform(q)
  return x

## testing
q = empty()
print "empty?", is_empty(q)
for x in range(10):
  queue(q,x)
  print "empty?", is_empty(q)
while not is_empty(q):
  print "dequeue:", dequeue(q)
print "empty?", is_empty(q)
