"""file: stack.py -- correction td6, exercises about stacks

"""

import random
import sys

def empty(): return []

def is_empty(st): return len(st) == 0

def push(st,elt):
  st.append(elt)
  return st

def pop(st):
  x = st[-1]
  del st[-1]
  return x

def polish(comp):
  st = empty()
  funs = {\
          '*': lambda a,b: a*b,\
          '+': lambda a,b: a+b,\
          '-': lambda a,b: a-b,\
          '/': lambda a,b: a//b\
  }
  for x in comp:
    if type(x) == int: push(st,x)
    else:
      a = pop(st)
      b = pop(st)
      push(st,funs[x](a,b))
  res = pop(st)
  assert is_empty(st)
  return res

## testing
# st = empty()
# print "empty?", is_empty(st)
# for x in range(10):
#   print "empty?", is_empty(push(st,x))
# while not is_empty(st):
#   print "pop:", pop(st)
# print "empty?", is_empty(st)
def try_int(c):
  try:
    return int(c)
  except ValueError:
    return c

print polish([try_int(c) for c in sys.argv[1].split(' ')])
